/*
 * gat_i2c.c
 *
 *  Created on: Oct 11, 2024
 *      Author: true
 *
 * implements a shoddy i2c slave.
 * maximum speed 100KHz tested.
 * note: not yet tested.
 */

#include <CH59x_common.h>

#include "gat_gpio.h"

#include "comm/soft_i2c_slave.h"

#include <stdint.h>



#define GAT_ADDR_BASE       0x30
#define GAT_I2C_SPEED       100000

#define GAT_DATA_SIZE       256



struct I2CSoftSlave gat_slave;

uint16_t gat_data_idx;
uint8_t gat_data[GAT_DATA_SIZE];





void gat_i2c_init()
{
    // determine I2C address from GP pin identification
    gat_slave.addr = gat_id + GAT_ADDR_BASE;

    // roughly guess bit time length for expected speed
    gat_slave.bit_time = GetSysClock() / GAT_I2C_SPEED / 4;

    // enable interrupt on SDA pin to detect start condition
    // this assumes GPIO has already been configured
}

void gat_i2c_irq_cb()
{
    i2css_blocking(&gat_slave);
}
